diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/buildings/test/buildings-pathloss-test.h ns-3.36/src/buildings/test/buildings-pathloss-test.h
--- ns-3.35/src/buildings/test/buildings-pathloss-test.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/buildings/test/buildings-pathloss-test.h	2022-04-30 18:23:57.782733200 -0700
@@ -28,8 +28,14 @@
 using namespace ns3;
 
 /**
-* Test 1.1 pathloss calculation
-*/
+ * \ingroup building-test
+ * \ingroup tests
+ *
+ * Test 1.1 BuildingsPathlossModel Pathloss compound test
+ *
+ * This TestSuite tests the BuildingPathlossModel by reproducing
+ * several communication scenarios 
+ */
 class BuildingsPathlossTestSuite : public TestSuite
 {
 public:
@@ -37,22 +43,44 @@
 };
 
 
+/**
+ * \ingroup building-test
+ * \ingroup tests
+ *
+ * Test 1.1 BuildingsPathlossModel Pathloss test
+ *
+ */
 class BuildingsPathlossTestCase : public TestCase
 {
 public:
+  /**
+   * Constructor
+   * \param freq Communication frequency
+   * \param m1 First MobilityModel Index
+   * \param m2 Second MobilityModel Index
+   * \param env Enviroment type
+   * \param city City size
+   * \param refValue Theoretical loss
+   * \param name Test name
+   */
   BuildingsPathlossTestCase (double freq, uint16_t m1, uint16_t m2, EnvironmentType env, CitySize city, double refValue, std::string name);
   virtual ~BuildingsPathlossTestCase ();
 
 private:
   virtual void DoRun (void);
+  /**
+   * Create a mobility model based on its index
+   * \param index MobilityModel index
+   * \return The MobilityModel
+   */
   Ptr<MobilityModel> CreateMobilityModel (uint16_t index);
 
-  double m_freq;
-  uint16_t m_mobilityModelIndex1;
-  uint16_t m_mobilityModelIndex2;
-  EnvironmentType m_env;
-  CitySize m_city;
-  double m_lossRef;
+  double m_freq; //!< Communication frequency
+  uint16_t m_mobilityModelIndex1; //!< First MobilityModel Index
+  uint16_t m_mobilityModelIndex2; //!< Second MobilityModel Index
+  EnvironmentType m_env; //!< Enviroment type
+  CitySize m_city; //!< City size
+  double m_lossRef; //!< Theoretical loss
 
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/buildings/test/buildings-shadowing-test.cc ns-3.36/src/buildings/test/buildings-shadowing-test.cc
--- ns-3.35/src/buildings/test/buildings-shadowing-test.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/buildings/test/buildings-shadowing-test.cc	2022-04-30 18:23:57.782733200 -0700
@@ -38,11 +38,9 @@
 NS_LOG_COMPONENT_DEFINE ("BuildingsShadowingTest");
 
 
-/**
+/*
 * Test 1.1 Shadowing compound test
-*/
-
-/**
+*
 * This TestSuite tests the shadowing model of BuildingPathlossModel 
 * by reproducing several communication scenarios 
 */
@@ -65,10 +63,11 @@
 
 }
 
+/// Static variable for test initialization
 static BuildingsShadowingTestSuite buildingsShadowingTestSuite;
 
 
-/**
+/*
 * TestCase
 */
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/buildings/test/buildings-shadowing-test.h ns-3.36/src/buildings/test/buildings-shadowing-test.h
--- ns-3.35/src/buildings/test/buildings-shadowing-test.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/buildings/test/buildings-shadowing-test.h	2022-04-30 18:23:57.782733200 -0700
@@ -28,7 +28,13 @@
 using namespace ns3;
 
 /**
- * Test shadowing calculation
+ * \ingroup building-test
+ * \ingroup tests
+ * 
+ * Shadowing compound test
+ *
+ * This TestSuite tests the shadowing model of BuildingPathlossModel 
+ * by reproducing several communication scenarios 
  */
 class BuildingsShadowingTestSuite : public TestSuite
 {
@@ -37,20 +43,39 @@
 };
 
 
+/**
+ * \ingroup building-test
+ * \ingroup tests
+ * 
+ * Shadowing test
+ */
 class BuildingsShadowingTestCase : public TestCase
 {
 public:
+  /**
+   * Constructor
+   * \param m1 First MobilityModel Index
+   * \param m2 Second MobilityModel Index
+   * \param refValue Theoretical loss
+   * \param sigmaRef Theoretical loss standard deviation
+   * \param name Test name
+   */
   BuildingsShadowingTestCase (uint16_t m1, uint16_t m2, double refValue, double sigmaRef, std::string name);
   virtual ~BuildingsShadowingTestCase ();
 
 private:
   virtual void DoRun (void);
+  /**
+   * Create a mobility model based on its index
+   * \param index MobilityModel index
+   * \return The MobilityModel
+   */
   Ptr<MobilityModel> CreateMobilityModel (uint16_t index);
 
-  uint16_t m_mobilityModelIndex1;
-  uint16_t m_mobilityModelIndex2;
-  double m_lossRef;     // pathloss value (without shadowing)
-  double m_sigmaRef;
+  uint16_t m_mobilityModelIndex1;  //!< First MobilityModel Index
+  uint16_t m_mobilityModelIndex2;  //!< Second MobilityModel Index
+  double m_lossRef;     //!< pathloss value (without shadowing)
+  double m_sigmaRef;    //!< pathloss standard deviation value reference value
 
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/buildings/test/outdoor-random-walk-test.cc ns-3.36/src/buildings/test/outdoor-random-walk-test.cc
--- ns-3.35/src/buildings/test/outdoor-random-walk-test.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/buildings/test/outdoor-random-walk-test.cc	2022-04-30 18:23:57.782733200 -0700
@@ -34,31 +34,28 @@
 NS_LOG_COMPONENT_DEFINE ("OutdoorRandomWalkTest");
 
 /**
+ * \ingroup building-test
+ * \ingroup tests
+ * 
  * Test case for the class OutdoorRandomWalkTestCase. It checks if the
  * positions visited by the user are outside buildings
  */
 class OutdoorRandomWalkTestCase : public TestCase
 {
 public:
-  /**
-   * Constructor
-   */
   OutdoorRandomWalkTestCase ();
-
-  /**
-   * Destructor
-   */
   virtual ~OutdoorRandomWalkTestCase ();
 
 private:
-  /**
-   * Builds the simulation scenario and perform the tests
-   */
   virtual void DoRun (void);
 
+  /**
+   * Check that the position is the expected one
+   * \param model Mobility model
+   */
   void CheckPositionOutdoor (Ptr<RandomWalk2dOutdoorMobilityModel> model);
 
-  std::vector<Ptr<Building> > m_buildings;
+  std::vector<Ptr<Building> > m_buildings; //!< Buildings
 };
 
 OutdoorRandomWalkTestCase::OutdoorRandomWalkTestCase ()
@@ -150,6 +147,9 @@
 }
 
 /**
+ * \ingroup building-test
+ * \ingroup tests
+ * 
  * Test suite for the buildings channel condition model
  */
 class OutdoorRandomWalkTestSuite : public TestSuite
@@ -164,4 +164,5 @@
   AddTestCase (new OutdoorRandomWalkTestCase, TestCase::QUICK);
 }
 
+/// Static variable for test initialization
 static OutdoorRandomWalkTestSuite OutdoorRandomWalkTestSuite;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/buildings/test/three-gpp-v2v-channel-condition-model-test.cc ns-3.36/src/buildings/test/three-gpp-v2v-channel-condition-model-test.cc
--- ns-3.35/src/buildings/test/three-gpp-v2v-channel-condition-model-test.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/buildings/test/three-gpp-v2v-channel-condition-model-test.cc	2022-04-30 18:23:57.782733200 -0700
@@ -38,6 +38,9 @@
 NS_LOG_COMPONENT_DEFINE ("ThreeGppV2vChannelConditionModelsTest");
 
 /**
+ * \ingroup building-test
+ * \ingroup tests
+ * 
  * Test case for the classes ThreeGppV2vUrbanChannelConditionModel,
  * and ThreeGppV2vHighwayChannelConditionModel to test their code to
  * deterministically determine NLOS state. The test checks if the
@@ -473,6 +476,9 @@
 
 
 /**
+ * \ingroup building-test
+ * \ingroup tests
+ * 
  * Test suite for the 3GPP V2V channel condition model
  *
  * Note that, in 3GPP V2V scenarios, the channel condition model is
@@ -483,8 +489,8 @@
  *
  * The test ThreeGppV2vBuildingsChCondModelTestCase checks the
  * 1st step of the procedure, the deterministic one, using buildings for
- * both \link ThreeGppV2vUrbanChannelConditionModel \endlink and
- * \link ThreeGppV2vHighwayChannelConditionModel \endlink .
+ * both \link ns3::ThreeGppV2vUrbanChannelConditionModel \endlink and
+ * \link ns3::ThreeGppV2vHighwayChannelConditionModel \endlink .
  *
  * The tests ThreeGppV2vUrbanLosNlosvChCondModelTestCase and
  * ThreeGppV2vHighwayLosNlosvChCondModelTestCase check the
@@ -506,4 +512,5 @@
   AddTestCase (new ThreeGppV2vHighwayLosNlosvChCondModelTestCase, TestCase::QUICK); // test for the probabilistic procedure (LOS vs NLOSv), in V2V highway scenario
 }
 
+/// Static variable for test initialization
 static ThreeGppV2vChCondModelsTestSuite ThreeGppV2vChCondModelsTestSuite;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/click/bindings/modulegen__gcc_ILP32.py ns-3.36/src/click/bindings/modulegen__gcc_ILP32.py
--- ns-3.35/src/click/bindings/modulegen__gcc_ILP32.py	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/click/bindings/modulegen__gcc_ILP32.py	2022-04-30 18:23:57.786733200 -0700
@@ -67,6 +67,8 @@
     module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::TraceSourceAccessor'])
     ## event-id.h (module 'core'): ns3::EventId [class]
     module.add_class('EventId', import_from_module='ns.core')
+    ## event-id.h (module 'core'): ns3::EventId::UID [enumeration]
+    module.add_enum('UID', ['INVALID', 'NOW', 'DESTROY', 'RESERVED', 'VALID'], outer_class=root_module['ns3::EventId'], import_from_module='ns.core')
     ## hash.h (module 'core'): ns3::Hasher [class]
     module.add_class('Hasher', import_from_module='ns.core')
     ## inet6-socket-address.h (module 'network'): ns3::Inet6SocketAddress [class]
@@ -113,8 +115,6 @@
     module.add_class('Mac8Address', import_from_module='ns.network')
     ## mac8-address.h (module 'network'): ns3::Mac8Address [class]
     root_module['ns3::Mac8Address'].implicitly_converts_to(root_module['ns3::Address'])
-    ## non-copyable.h (module 'core'): ns3::NonCopyable [class]
-    module.add_class('NonCopyable', destructor_visibility='protected', import_from_module='ns.core')
     ## object-base.h (module 'core'): ns3::ObjectBase [class]
     module.add_class('ObjectBase', allow_subclassing=True, import_from_module='ns.core')
     ## object.h (module 'core'): ns3::ObjectDeleter [struct]
@@ -473,7 +473,6 @@
     register_Ns3LogComponent_methods(root_module, root_module['ns3::LogComponent'])
     register_Ns3Mac48Address_methods(root_module, root_module['ns3::Mac48Address'])
     register_Ns3Mac8Address_methods(root_module, root_module['ns3::Mac8Address'])
-    register_Ns3NonCopyable_methods(root_module, root_module['ns3::NonCopyable'])
     register_Ns3ObjectBase_methods(root_module, root_module['ns3::ObjectBase'])
     register_Ns3ObjectDeleter_methods(root_module, root_module['ns3::ObjectDeleter'])
     register_Ns3PacketMetadata_methods(root_module, root_module['ns3::PacketMetadata'])
@@ -2062,12 +2061,6 @@
                    is_static=True)
     return
 
-def register_Ns3NonCopyable_methods(root_module, cls):
-    ## non-copyable.h (module 'core'): ns3::NonCopyable::NonCopyable() [constructor]
-    cls.add_constructor([], 
-                        visibility='protected')
-    return
-
 def register_Ns3ObjectBase_methods(root_module, cls):
     ## object-base.h (module 'core'): ns3::ObjectBase::ObjectBase() [constructor]
     cls.add_constructor([])
@@ -2930,14 +2923,14 @@
     cls.add_binary_comparison_operator('<=')
     cls.add_binary_comparison_operator('>=')
     cls.add_output_stream_operator()
-    cls.add_binary_comparison_operator('==')
-    cls.add_binary_comparison_operator('<')
-    cls.add_binary_comparison_operator('>')
-    cls.add_inplace_numeric_operator('+=', param('ns3::int64x64_t const &', 'right'))
-    cls.add_inplace_numeric_operator('-=', param('ns3::int64x64_t const &', 'right'))
-    cls.add_inplace_numeric_operator('*=', param('ns3::int64x64_t const &', 'right'))
-    cls.add_inplace_numeric_operator('/=', param('ns3::int64x64_t const &', 'right'))
     cls.add_unary_numeric_operator('-')
+    cls.add_inplace_numeric_operator('/=', param('ns3::int64x64_t const &', 'right'))
+    cls.add_inplace_numeric_operator('*=', param('ns3::int64x64_t const &', 'right'))
+    cls.add_inplace_numeric_operator('-=', param('ns3::int64x64_t const &', 'right'))
+    cls.add_inplace_numeric_operator('+=', param('ns3::int64x64_t const &', 'right'))
+    cls.add_binary_comparison_operator('>')
+    cls.add_binary_comparison_operator('<')
+    cls.add_binary_comparison_operator('==')
     ## int64x64-128.h (module 'core'): ns3::int64x64_t::int64x64_t() [constructor]
     cls.add_constructor([])
     ## int64x64-128.h (module 'core'): ns3::int64x64_t::int64x64_t(double const value) [constructor]
@@ -2956,6 +2949,8 @@
     cls.add_constructor([param('long unsigned int const', 'v')])
     ## int64x64-128.h (module 'core'): ns3::int64x64_t::int64x64_t(long long unsigned int const v) [constructor]
     cls.add_constructor([param('long long unsigned int const', 'v')])
+    ## int64x64-128.h (module 'core'): ns3::int64x64_t::int64x64_t(int128_t const v) [constructor]
+    cls.add_constructor([param('int128_t const', 'v')])
     ## int64x64-128.h (module 'core'): ns3::int64x64_t::int64x64_t(int64_t const hi, uint64_t const lo) [constructor]
     cls.add_constructor([param('int64_t const', 'hi'), param('uint64_t const', 'lo')])
     ## int64x64-128.h (module 'core'): ns3::int64x64_t::int64x64_t(ns3::int64x64_t const & o) [constructor]
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/click/bindings/modulegen__gcc_LP64.py ns-3.36/src/click/bindings/modulegen__gcc_LP64.py
--- ns-3.35/src/click/bindings/modulegen__gcc_LP64.py	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/click/bindings/modulegen__gcc_LP64.py	2022-04-30 18:23:57.786733200 -0700
@@ -67,6 +67,8 @@
     module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::TraceSourceAccessor'])
     ## event-id.h (module 'core'): ns3::EventId [class]
     module.add_class('EventId', import_from_module='ns.core')
+    ## event-id.h (module 'core'): ns3::EventId::UID [enumeration]
+    module.add_enum('UID', ['INVALID', 'NOW', 'DESTROY', 'RESERVED', 'VALID'], outer_class=root_module['ns3::EventId'], import_from_module='ns.core')
     ## hash.h (module 'core'): ns3::Hasher [class]
     module.add_class('Hasher', import_from_module='ns.core')
     ## inet6-socket-address.h (module 'network'): ns3::Inet6SocketAddress [class]
@@ -113,8 +115,6 @@
     module.add_class('Mac8Address', import_from_module='ns.network')
     ## mac8-address.h (module 'network'): ns3::Mac8Address [class]
     root_module['ns3::Mac8Address'].implicitly_converts_to(root_module['ns3::Address'])
-    ## non-copyable.h (module 'core'): ns3::NonCopyable [class]
-    module.add_class('NonCopyable', destructor_visibility='protected', import_from_module='ns.core')
     ## object-base.h (module 'core'): ns3::ObjectBase [class]
     module.add_class('ObjectBase', allow_subclassing=True, import_from_module='ns.core')
     ## object.h (module 'core'): ns3::ObjectDeleter [struct]
@@ -473,7 +473,6 @@
     register_Ns3LogComponent_methods(root_module, root_module['ns3::LogComponent'])
     register_Ns3Mac48Address_methods(root_module, root_module['ns3::Mac48Address'])
     register_Ns3Mac8Address_methods(root_module, root_module['ns3::Mac8Address'])
-    register_Ns3NonCopyable_methods(root_module, root_module['ns3::NonCopyable'])
     register_Ns3ObjectBase_methods(root_module, root_module['ns3::ObjectBase'])
     register_Ns3ObjectDeleter_methods(root_module, root_module['ns3::ObjectDeleter'])
     register_Ns3PacketMetadata_methods(root_module, root_module['ns3::PacketMetadata'])
@@ -2062,12 +2061,6 @@
                    is_static=True)
     return
 
-def register_Ns3NonCopyable_methods(root_module, cls):
-    ## non-copyable.h (module 'core'): ns3::NonCopyable::NonCopyable() [constructor]
-    cls.add_constructor([], 
-                        visibility='protected')
-    return
-
 def register_Ns3ObjectBase_methods(root_module, cls):
     ## object-base.h (module 'core'): ns3::ObjectBase::ObjectBase() [constructor]
     cls.add_constructor([])
@@ -2930,14 +2923,14 @@
     cls.add_binary_comparison_operator('<=')
     cls.add_binary_comparison_operator('>=')
     cls.add_output_stream_operator()
-    cls.add_binary_comparison_operator('==')
-    cls.add_binary_comparison_operator('<')
-    cls.add_binary_comparison_operator('>')
-    cls.add_inplace_numeric_operator('+=', param('ns3::int64x64_t const &', 'right'))
-    cls.add_inplace_numeric_operator('-=', param('ns3::int64x64_t const &', 'right'))
-    cls.add_inplace_numeric_operator('*=', param('ns3::int64x64_t const &', 'right'))
-    cls.add_inplace_numeric_operator('/=', param('ns3::int64x64_t const &', 'right'))
     cls.add_unary_numeric_operator('-')
+    cls.add_inplace_numeric_operator('/=', param('ns3::int64x64_t const &', 'right'))
+    cls.add_inplace_numeric_operator('*=', param('ns3::int64x64_t const &', 'right'))
+    cls.add_inplace_numeric_operator('-=', param('ns3::int64x64_t const &', 'right'))
+    cls.add_inplace_numeric_operator('+=', param('ns3::int64x64_t const &', 'right'))
+    cls.add_binary_comparison_operator('>')
+    cls.add_binary_comparison_operator('<')
+    cls.add_binary_comparison_operator('==')
     ## int64x64-128.h (module 'core'): ns3::int64x64_t::int64x64_t() [constructor]
     cls.add_constructor([])
     ## int64x64-128.h (module 'core'): ns3::int64x64_t::int64x64_t(double const value) [constructor]
@@ -2956,6 +2949,8 @@
     cls.add_constructor([param('long unsigned int const', 'v')])
     ## int64x64-128.h (module 'core'): ns3::int64x64_t::int64x64_t(long long unsigned int const v) [constructor]
     cls.add_constructor([param('long long unsigned int const', 'v')])
+    ## int64x64-128.h (module 'core'): ns3::int64x64_t::int64x64_t(int128_t const v) [constructor]
+    cls.add_constructor([param('int128_t const', 'v')])
     ## int64x64-128.h (module 'core'): ns3::int64x64_t::int64x64_t(int64_t const hi, uint64_t const lo) [constructor]
     cls.add_constructor([param('int64_t const', 'hi'), param('uint64_t const', 'lo')])
     ## int64x64-128.h (module 'core'): ns3::int64x64_t::int64x64_t(ns3::int64x64_t const & o) [constructor]
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/click/CMakeLists.txt ns-3.36/src/click/CMakeLists.txt
--- ns-3.35/src/click/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/click/CMakeLists.txt	2022-04-30 18:23:57.782733200 -0700
@@ -0,0 +1,56 @@
+set(NS3_WITH_CLICK
+    ""
+    CACHE PATH
+          "Build with click support"
+)
+set(NS3_CLICK
+    "OFF"
+    CACHE INTERNAL
+          "ON if Click is found in NS3_WITH_CLICK"
+)
+
+find_external_library(
+  DEPENDENCY_NAME click
+  HEADER_NAME simclick.h
+  LIBRARY_NAMES nsclick
+                click
+  SEARCH_PATHS ${NS3_WITH_CLICK}
+)
+
+if((NOT
+    click_FOUND)
+   AND (NOT
+        ${click_FOUND})
+)
+  message(
+    ${HIGHLIGHTED_STATUS}
+    "Skipping src/click"
+  )
+  return()
+endif()
+
+include_directories(${click_INCLUDE_DIRS})
+set(NS3_CLICK
+    "ON"
+    CACHE INTERNAL
+          "ON if Click is found in NS3_WITH_CLICK"
+)
+add_definitions(-DNS3_CLICK)
+
+build_lib(
+  LIBNAME click
+  SOURCE_FILES
+    helper/click-internet-stack-helper.cc
+    model/ipv4-click-routing.cc
+    model/ipv4-l3-click-protocol.cc
+  HEADER_FILES
+    helper/click-internet-stack-helper.h
+    model/ipv4-click-routing.h
+    model/ipv4-l3-click-protocol.h
+  LIBRARIES_TO_LINK
+    ${libcore}
+    ${libnetwork}
+    ${libinternet}
+    ${click_LIBRARIES}
+  TEST_SOURCES test/ipv4-click-routing-test.cc
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/click/examples/CMakeLists.txt ns-3.36/src/click/examples/CMakeLists.txt
--- ns-3.35/src/click/examples/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/click/examples/CMakeLists.txt	2022-04-30 18:23:57.786733200 -0700
@@ -0,0 +1,55 @@
+build_lib_example(
+  NAME nsclick-simple-lan
+  SOURCE_FILES nsclick-simple-lan.cc
+  LIBRARIES_TO_LINK
+    ${libclick}
+    ${libcsma}
+    ${libinternet}
+    ${libapplications}
+)
+
+build_lib_example(
+  NAME nsclick-raw-wlan
+  SOURCE_FILES nsclick-raw-wlan.cc
+  LIBRARIES_TO_LINK
+    ${libclick}
+    ${libwifi}
+    ${libinternet}
+    ${libapplications}
+)
+
+build_lib_example(
+  NAME nsclick-udp-client-server-csma
+  SOURCE_FILES nsclick-udp-client-server-csma.cc
+  LIBRARIES_TO_LINK
+    ${libclick}
+    ${libcsma}
+    ${libinternet}
+    ${libapplications}
+)
+
+build_lib_example(
+  NAME nsclick-udp-client-server-wifi
+  SOURCE_FILES nsclick-udp-client-server-wifi.cc
+  LIBRARIES_TO_LINK
+    ${libclick}
+    ${libwifi}
+    ${libinternet}
+    ${libapplications}
+)
+
+build_lib_example(
+  NAME nsclick-routing
+  SOURCE_FILES nsclick-routing.cc
+  LIBRARIES_TO_LINK
+    ${libclick}
+    ${libcsma}
+    ${libinternet}
+    ${libapplications}
+)
+
+build_lib_example(
+  NAME nsclick-defines
+  SOURCE_FILES nsclick-defines.cc
+  LIBRARIES_TO_LINK ${libclick}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/CMakeLists.txt ns-3.36/src/CMakeLists.txt
--- ns-3.35/src/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/CMakeLists.txt	2022-04-30 18:23:57.726733000 -0700
@@ -0,0 +1,82 @@
+set(libs "${libs_to_build}")
+
+# Process the visualizer module first if enabled
+if(visualizer IN_LIST libs)
+  if(${ENABLE_VISUALIZER})
+    message(STATUS "Processing src/visualizer")
+    add_subdirectory(visualizer)
+  endif()
+  list(REMOVE_ITEM libs visualizer)
+endif()
+
+# Process subdirectories
+foreach(libname ${libs})
+  if(EXISTS ${PROJECT_SOURCE_DIR}/src/${libname}/CMakeLists.txt)
+    message(STATUS "Processing src/${libname}")
+    add_subdirectory(${libname})
+  else()
+    message(
+      ${HIGHLIGHTED_STATUS}
+      "Skipping src/${libname} : it does not contain a CMakeLists.txt file"
+    )
+  endif()
+endforeach()
+
+# Build the lib-ns3-static (ns3.x-static-buildtype.a/.lib) with all sublibraries
+if(${NS3_STATIC})
+  add_library(
+    ${lib-ns3-static} STATIC ${PROJECT_SOURCE_DIR}/build-support/empty.cc
+                             "${lib-ns3-static-objs}"
+  )
+
+  # Replace shared library suffix and check if static version exists before
+  # linking
+  set(ns3-external-static-libs)
+  foreach(sharedlib ${ns3-external-libs})
+    if(NOT (${sharedlib} MATCHES ".so"))
+      list(APPEND ns3-external-static-libs ${sharedlib})
+      continue()
+    endif()
+
+    string(REPLACE ".so" ".a" output ${sharedlib})
+    if(EXISTS ${output})
+      list(APPEND ns3-external-static-libs ${output})
+    else()
+      message(
+        FATAL_ERROR "Static library version of ${sharedlib} was not found"
+      )
+    endif()
+  endforeach()
+
+  target_link_libraries(
+    ${lib-ns3-static}
+    -static
+    -static-libstdc++
+    -static-libgcc
+    ${LIB_AS_NEEDED_PRE_STATIC}
+    ${ns3-external-static-libs}
+    ${LIB_AS_NEEDED_POST_STATIC}
+  )
+  if(${NS3_CLANG_TIMETRACE})
+    add_dependencies(timeTraceReport ${lib-ns3-static})
+  endif()
+endif()
+
+# Build the lib-ns3-static (ns3.x-monolib-buildtype.dll/.dylib/.so) with all
+# sublibraries
+if(${NS3_MONOLIB})
+  add_library(
+    ${lib-ns3-monolib} SHARED ${PROJECT_SOURCE_DIR}/build-support/empty.cc
+                              "${lib-ns3-static-objs}"
+  )
+  set_target_properties(
+    ${lib-ns3-monolib} PROPERTIES INTERPROCEDURAL_OPTIMIZATION TRUE
+  )
+  target_link_libraries(
+    ${lib-ns3-monolib} ${LIB_AS_NEEDED_PRE} ${ns3-external-libs}
+    ${LIB_AS_NEEDED_POST}
+  )
+  if(${NS3_CLANG_TIMETRACE})
+    add_dependencies(timeTraceReport ${lib-ns3-monolib})
+  endif()
+endif()
